function string.rep(str, depth)
  local out = ""
  while depth > 0 do
    out = out .. str
	depth = depth - 1
  end
  return out
end

function print_table(tab, depth)
  depth = depth or 0
  local str = ""
  if "table" == type(tab) then
	  for k,v in pairs(tab) do
	    str = str .. print_table(k) .. " =\n"
	    str = str .. print_table(v, depth + 1) .. "\n"
	  end
  else
    return string.rep(" ", depth) .. tostring(tab) .. " ("..type(tab):sub(1,1)..")"
  end
  return str
end

function display()
 digiline_send("controller", print_table(mem[mem.current]).."\n "..tostring(mem.current).."/"..tostring(#mem))
end

if event.type == "digiline" then
  if event.channel == "controller" then
    if event.msg == "up" then
      if mem[mem.current - 1] then
        mem.current = mem.current - 1
      end
    elseif event.msg == "down" then
      if mem[mem.current + 1] then
        mem.current = mem.current + 1
      end
    elseif event.msg == "back" then
      while mem[1] do
        table.remove(mem, 1)
      end
      mem.current = 1
    end
    display()
  else
    table.insert(mem, {event.channel, event.msg})
  end
elseif event.type == "program" then
  mem.current = mem.current or 1
  if #mem > 0 then
    display()
  end
  mem.delayed = mem.delayed or {}
  -- table.insert(mem.delayed, function() digiline_send("filter", "sand") end)
  -- table.insert(mem.delayed, function() digiline_send("filter", "stone") end)
  table.insert(mem.delayed, function() digiline_send("craft","GET") end)
  interrupt(4)
elseif event.type == "interrupt" then
  if #mem.delayed > 0 then
    table.remove(mem.delayed, 1)()
    table.insert(mem, {delayed = "ran a fn"})
  end
  interrupt(4)
end