-- mem.count stores material counts of every material that has come through this tube
-- mem.total stores a total count of the number of items that have come through
-- the connected display allows viewing this count (using arrows, back, and enter to jump through the list)
-- send a pattern on "find" channel to retrieve matches through "findresults" channel

local send = function()
  local name = mem.list[mem.pointer]
  digiline_send("display", "["..tostring(mem.pointer).."/"..tostring(#mem.list).."] "..tostring(mem.count[name]).." "..tostring(name).."\nTotal items: "..tostring(mem.total).." Heat: "..tostring(heat))
end

if event.type == "digiline" then

  if event.channel == "incoming" then
    if mem.count[event.msg] then
      mem.count[event.msg] = mem.count[event.msg] + 1 -- increment the count for this item
    else
      mem.count[event.msg] = 1
      table.insert(mem.list, event.msg) -- make sure we can view this count later
    end
    mem.total = mem.total + 1
    send()

  elseif event.channel == "display" then
    if event.msg == "up" then
      if mem.list[mem.pointer - 1] then
        mem.pointer = mem.pointer - 1
      end
    elseif event.msg == "down" then
      if mem.list[mem.pointer + 1] then
        mem.pointer = mem.pointer + 1
      end
    elseif event.msg == "enter" then
      mem.pointer = #mem.list
    elseif event.msg == "back" then
      mem.pointer = 1
    elseif event.msg == "left" then
      if mem.list[mem.pointer - 10] then
        mem.pointer = mem.pointer - 10
      end
    elseif event.msg == "right" then
      if mem.list[mem.pointer + 10] then
        mem.pointer = mem.pointer + 10
      end
    end
    send()

  -- this doesn't work?
  elseif event.channel == "find" then
    local results = {}
    for k,v in pairs(item.count) do
      if k:find(event.msg) then
        table.insert(results, {k, v})
      end
    end
    digiline_send("findresults", results)
  end

elseif event.type == "program" then
  mem.count = mem.count or {} -- creating the table holding counts if it doesn't exist
  mem.list = mem.list or {}         -- this is a flat list used for iterating over the counts
  mem.pointer = mem.pointer or 1
  mem.total = mem.total or 0
  send()
end