-- sorty mcsortface v0.3
--   configuration (edit as needed)

local pass = "blue" -- pass is used for anything that cannot be sorted
local grind = "white" -- any other names can be used for your configuration
local smelt = "white"
local decorative = "yellow"
local waste = "yellow"
local tools = "black"
local component = "black"
local construction = "green"

local items = { -- item names are exact, so a hash table is used
  ["technic:rubber_tree_grindings"] = pass,
  ["moretrees:rubber_tree_trunk"] = grind,
  ["default:coal_lump"] = pass,
  ["technic:coal_dust"] = construction,
  ["default:mossycoble"] = waste,
  --["basic_materials:steel_bar"] = component,
  --["basic_materials:padlock"] = component,
  ["mobs:nametag"] = tools,
  ["default:torch"] = tools,
  ["vacuum:air_bottle"] = tools,
  ["technic:lead_block"] = pass,
  ["technic:zinc_block"] = pass,
  ["default:flint"] = tools,
  ["bridger:scaffolding"] = decorative,
  ["bones:bones"] = decorative,
  ["default:ice"] = decorative,
  ["default:gravel"] = waste,
  ["hangglider:hangglider"] = tools,
}

local patterns = { -- patterns are prioritized by their order in this list
  { "lump", grind },
  { "uranium", construction },
  { "dust", smelt },
  { "ingot", pass },
  { "drill", tools },
  { "technic", construction },
  { "screwdriver", tools },

  { "basic_materials", component },

  { "plastic", decorative },
  { "stone", waste },
  { "digtron", tools },
  { "currency", tools },
  { "hazmat_suit", tools },
  { "3d_armor", tools },
  { "bag", tools },
  { "vessels", tools },
  { "bucket", tools },
  { "ropes", tools },
  { "hoe", tools },
  { "pick", tools },
  { "anvil", tools },
  { "sword", tools },
  { "shovel", tools },
  { "axe", tools },
  { "computer:", decorative },
  { "scifi", decorative },
  { "pipeworks", construction },
  { "sand", waste },
  { "cobble", waste },
  { "brick", decorative },
  { "digi", construction },
  { "mese", construction },
  { "micro", decorative },
  { "slab", decorative },
  { "prefab", decorative },
  { "clay", decorative },
  { "protector", tools },
  { "factory_bridges", decorative },
  { "multitools", tools },
  { "bed", decorative },
  { "chest", tools },
  { "homedecor", decorative },

  { "ehl", decorative },
}

---- program (do not edit) ----

if event.type == "item" then
  local name = event.item.name
  if items[name] then
    return items[name]
  end
  for _, pattern in ipairs(patterns) do
    if name:find(pattern[1], 0, true) then
      return pattern[2]
    end
  end
  return pass
end

---- features to be considered:
-- respond to health check
-- report unrecognized items
-- keep count of items passing through